#!/usr/bin/perl

use strict;

require "inc/cwcal.pl";

sub print_tree
{
    my $conf_ref = shift;
    my $uconf = cw_get_uconf();
    my $gconf = cw_get_gconf();
    my $msgdelus = __("Supprimer l'utilisateur");
    my $msgedus = __("Modifier l'utilisateur");
    my $msgdelgr = __("Supprimer le groupe");
    my $msgedgr = __("Modifier le groupe");
    my $msgaddus = __("Crer un utilisateur");
    my $msgaddgr = __("Crer un groupe");
    my $msgsortus = __("Trier les utilisateurs");
    my $msgsortgr = __("Trier les groupes");
    my $msgaccess = __("Contrle d'accs");

    if ($conf_ref->{groups})
    {
	my $group;
	my $del;
	my $user;
	my $us;
	my $gr;
	my $cref;
	my $cref2;
	my $gr2;
	my $ingr;
	foreach $group (cw_get_groups($conf_ref))
	{
	    print '<table><tr><td><a href="group.cgi?id='.$group.'"><img src="images/group1.gif" border=0 alt="'.$group.'" title="'.$group.'"></a></td>';
	    print "<td><select onchange=group_action(this)>\n";
	    print "<option>$gconf->{$group}->{'long name'}\n";
	    print '<option value="user.cgi?addus=1&group='.$group.'">'.$msgaddus."\n";
	    print '<option value="group.cgi?addgr=1&group='.$group.'">'.$msgaddgr."\n";
	    if ($gconf->{$group}->{"users"} && scalar(@{$gconf->{$group}->{"users"}}) > 1)
	    {
		print '<option value="usorder.cgi?group='.$group.'">'.$msgsortus."\n";
	    }
	    if ($gconf->{$group}->{"groups"} && scalar(@{$gconf->{$group}->{"groups"}}) > 1)
	    {
		print '<option value="grorder.cgi?group='.$group.'">'.$msgsortgr."\n";
	    }
	    print '<option value="group.cgi?id='.$group.'">'.$msgedgr."\n";
	    $del = 1;
	    foreach $user (%{$uconf})
	    {
		$cref = $uconf->{$user};
		while ($gr = $cref->{group})
		{
		    if ($gr eq $group)
		    {
			foreach $us (%{$uconf})
			{
			    if ($us ne $user && $uconf->{$us}->{'data id'} && $uconf->{$us}->{'data id'} eq $user)
			    {
				$cref2 = $uconf->{$us};
				$ingr = 0;
				while ($gr2 = $cref2->{group})
				{
				    if ($gr2 eq $group)
				    {
					$ingr = 1;
					last;
				    }
				    else
				    {
					$cref2 = $gconf->{$gr2};
				    }
				}
				if (!$ingr)
				{
				    $del = 0;
				    last;
				}
			    }
			}
			last;
		    }
		    else
		    {
			$cref = $gconf->{$gr};
		    }
		}
		if (!$del)
		{
		    last;
		}
	    }
	    if ($del)
	    {
		print '<option value="'.$group."__".$gconf->{$group}->{'long name'}.'">'.$msgdelgr."\n";
	    }
	    print '<option value="access.cgi?group='.$group.'">'.$msgaccess."\n";
	    print "</select></td>";
	    if ($gconf->{$group}->{"access file"})
	    {
		my $line;
		foreach $line (split(/\n/, $gconf->{$group}->{"access file"}))
		{
		    if ($line =~ /\s*require\s*(.*\S)/i)
		    {
			print '<td><a href="access.cgi?group='.$group.'"><img src="images/alarm.gif" border=0 alt="'.$1.'" title="'.$1.'"></a></td>';
			last;
		    }
		}
	    }
	    print "</tr></table>\n";
	    print "<ul>\n";
	    print_tree($gconf->{$group});
	    print "</ul>\n";
	}
    }
    print "<p>\n";
    if ($conf_ref->{users})
    {
	my $user;
	my $us;
	my $del;
	foreach $user (cw_get_users($conf_ref))
	{
	    print '<table><tr><td><a href="user.cgi?id='.$user.'"><img src="images/user.gif" border=0 alt="'.$user.'" title="'.$user.'"></a></td>';
	    print "<td><select onchange=user_action(this)>\n";
	    print "<option>$uconf->{$user}->{'long name'}\n";
	    print '<option value="user.cgi?id='.$user.'">'.$msgedus."\n";
	    $del = 1;
	    foreach $us (%{$uconf})
	    {
		if ($us ne $user && $uconf->{$us}->{'data id'} && $uconf->{$us}->{'data id'} eq $user)
		{
		    $del = 0;
		    last;
		}
	    }
	    if ($del)
	    {
		print '<option value="'.$user."__".$uconf->{$user}->{'long name'}.'">'.$msgdelus."\n";
	    }
	    print '<option value="access.cgi?user='.$user.'">'.$msgaccess."\n";
	    print "</select></td>";
	    if ($uconf->{$user}->{'data id'})
	    {
		my $alt = $uconf->{$uconf->{$user}->{'data id'}}->{'long name'};
		my $group = $uconf->{$uconf->{$user}->{'data id'}}->{group};
		while ($group)
		{
		    $alt = "$gconf->{$group}->{'long name'} / $alt";
		    $group = $gconf->{$group}->{group};
		}
		if ($uconf->{$user}->{'read only'} eq "true")
		{
		    $alt = "R : $alt";
		}
		$alt = cw_unquote($alt);
		print '<td><a href="user.cgi?id='.$uconf->{$user}->{'data id'}.'"><img src="images/mail.gif" border=0" alt="'.$alt.'" title="'.$alt.'"></a></td>';
	    }
	    if ($uconf->{$user}->{"access file"})
	    {
		my $line;
		foreach $line (split(/\n/, $uconf->{$user}->{"access file"}))
		{
		    if ($line =~ /\s*require\s*(.*\S)/i)
		    {
			print '<td><a href="access.cgi?user='.$user.'"><img src="images/alarm.gif" border=0 alt="'.$1.'" title="'.$1.'"></a></td>';
			last;
		    }
		}
	    }
	    print "</td></tr></table>\n";
	}
    }
}

my $title2 = __("Configuration Wcal");
my $title = __("Utilisateurs et groupes");

cw_header($title);

print "<center>\n";
print "<h1><a href=\".\">$title2</a></h1>\n";
print "</center>\n";
print "<h2>$title</h2>\n";

my $wconf = cw_get_wconf();

print "<script language=javascript>\n";
print "function user_action(optfield)\n";
print "{\n";
print "  var value = optfield.options[optfield.selectedIndex].value;\n";
print "  if (value)\n";
print "  {\n";
print "    var vals = new Array();\n";
print "    vals = value.split('__');\n";
print "    if (vals[1])\n";
print "    {\n";
print '      var str = "'.__("Voulez-vous rellement supprimer l'utilisateur %s ?").'";'."\n";
print "      var ts = new Array();\n";
print "      ts = str.split('%s');\n";
print "      str = ts[0]+vals[1]+ts[1];\n";
print "      if (confirm(str)) top.location.href = 'user.cgi?delete=1&id='+vals[0];\n";
print "      else optfield.selectedIndex = 0;\n";
print "    }\n";
print "    else\n";
print "    {\n";
print "      top.location.href = vals[0];\n";
print "    }\n";
print "  }\n";
print "}\n";
print "function group_action(optfield)\n";
print "{\n";
print "  var value = optfield.options[optfield.selectedIndex].value;\n";
print "  if (value)\n";
print "  {\n";
print "    var vals = new Array();\n";
print "    vals = value.split('__');\n";
print "    if (vals[1])\n";
print "    {\n";
print '      var str = "'.__("Voulez-vous rellement supprimer le groupe %s ?").'";'."\n";
print "      var ts = new Array();\n";
print "      ts = str.split('%s');\n";
print "      str = ts[0]+vals[1]+ts[1];\n";
print "      if (confirm(str)) top.location.href = 'group.cgi?delete=1&id='+vals[0];\n";
print "      else optfield.selectedIndex = 0;\n";
print "    }\n";
print "    else\n";
print "    {\n";
print "      top.location.href = vals[0];\n";
print "    }\n";
print "  }\n";
print "}\n";
print "</script>\n";

print "<form method=post>\n";

my $msgaddus = __("Crer un utilisateur");
my $msgaddgr = __("Crer un groupe");
my $msgsortus = __("Trier les utilisateurs");
my $msgsortgr = __("Trier les groupes");
my $msgaccess = __("Contrle d'accs");
print "<table><tr><td>\n";
print "<select onchange=group_action(this)>\n";
print "<option>Wcal\n";
print '<option value="user.cgi?addus=1">'.$msgaddus."\n";
print '<option value="group.cgi?addgr=1">'.$msgaddgr."\n";
if ($wconf->{"users"} && scalar(@{$wconf->{"users"}}) > 1)
{
    print '<option value="usorder.cgi">'.$msgsortus."\n";
}
if ($wconf->{"groups"} && scalar(@{$wconf->{"groups"}}) > 1)
{
    print '<option value="grorder.cgi">'.$msgsortgr."\n";
}
print '<option value="access.cgi">'.$msgaccess."\n";
print "</select>\n</td>\n";
if ($wconf->{"access file"})
{
    my $line;
    foreach $line (split(/\n/, $wconf->{"access file"}))
    {
	if ($line =~ /\s*require\s*(.*\S)/i)
	{
	    print '<td><a href="access.cgi"><img src="images/alarm.gif" border=0 alt="'.$1.'" title="'.$1.'"></a></td>';
	    last;
	}
    }
}
print "</tr></table>\n";
print "<p>\n";

print_tree($wconf);
print "</form>\n";

cw_footer();
