#!/usr/bin/perl

use strict;
use CGI();

require "inc/cwcal.pl";

my $q = new CGI();

my $group = $q->param("id");

if ($q->param("delete"))
{
    cw_write_gconf($group);
    print $q->redirect("usgr.cgi");
}

my $title = __("Configuration Wcal");
my $title2 = __("Utilisateurs et groupes");
my $txt1 = __("Ressources renseignes");
my $txt2 = __("Toutes les ressources");
my $title3;

cw_header($title);

print "<center>\n";
print "<h1><a href=\".\">$title</a></h1>\n";
print "</center>\n";
print "<h2><a href=\"usgr.cgi\">$title2</a></h2>\n";

my $gconf = cw_get_gconf();
my $uconf = cw_get_uconf();
my $conf;

if ($group)
{
    $conf = $gconf->{$group};
}
else
{
    $conf = {};
    $conf->{group} = $q->param("group");
}

my $conf_ref = $conf;
my $sep = "";
my $str = "";
my $grp;
while ($grp = $conf_ref->{group})
{
    $str = '<a href="group.cgi?id='.$grp.'"><img src="images/group1.gif" border=0 alt="'.$grp.'" title="'.$grp.'"></a> '.$gconf->{$grp}->{"long name"}.$sep.$str;
    $sep = " / ";
    $conf_ref = $gconf->{$grp};
}
if ($str)
{
    print "<h3>$str</h3>\n";
}
my $url;

if ($group)
{
    $title3 = sprintf(__("Groupe %s"), $group);
    $url = "group.cgi?id=$group";
}
else
{
    $title3 = __("Nouveau groupe");
    $url = "group.cgi?addgr=1&group=".$q->param("group");
}

print "<h3>$title3</h3>\n";

if ($q->param("all"))
{
    print "<i><a href=\"$url\"><font color=\"#666666\">$txt1</font></a></i>&nbsp;&nbsp;&nbsp;<b>$txt2</b>\n";
}
else
{
    print " <b>$txt1</b>&nbsp;&nbsp;&nbsp;<i><a href=\"$url&all=1\"><font color=\"#666666\">$txt2</font></a></i>\n";
}

print "<p>\n";

if ($q->param("long name"))
{
    $conf->{"long name"} = $q->param("long name");
    
    my $key;
    my $def;
    my $val;
    
    while (($key, $def) = each(%{$::DEFAULTS}))
    {
	$val = $q->param("$key");
	if ($q->param("__$key"))
	{
	    delete $conf->{"$key"};
	}
	elsif (defined $val && ((defined $conf->{"$key"}) || $val ne $def))
	{
	    $conf->{"$key"} = $val;
	}
    }
    if ($group)
    {
	cw_write_gconf($group, $conf);
	print '<font color="#00aa00" size=4>'.__("Configuration groupe modifie")."</font>\n";
    }
    else
    {
	if ($uconf->{$q->param("wcal id")} || $gconf->{$q->param("wcal id")})
	{
	    print '<font color="red" size=4>'.sprintf(__("Identifiant %s dj utilis"), $q->param("wcal id"))."</font>\n";
	}
	else
	{
	    cw_add_wcobj($q->param("wcal id"), "group", $conf, $q->param("group"));
	    print '<font color="#00aa00" size=4>'.sprintf(__("Groupe %s ajout"), '<a href="group.cgi?id='.$q->param("wcal id").'">'.$q->param("wcal id").'</a>')."</font>\n";
	}
    }
}
print "<form method=post>\n";
print "<table>\n";

if (!$group)
{
    cw_field("wcal id", $conf, $q, 0, "", 1, "helpwcid.cgi");
}

# long name
cw_field("long name", $conf, $q, 32, "", 1);

# display
cw_topic("Affichage");
cw_field("date format", $conf, $q, 0, "cw_get_date_fmt");
cw_field("clock", $conf, $q, 0, "cw_get_clock");

# alarms
cw_topic("Alarmes");
cw_field("remote mail", $conf, $q);
cw_field("mail command", $conf, $q);

# misc
cw_topic("Divers");
cw_field("default todo", $conf, $q, 0, "cw_get_true_false");
cw_field("disable fusion", $conf, $q, 0, "cw_get_true_false");
cw_field("disable purge", $conf, $q, 0, "cw_get_true_false");

print "<tr><td colspan=2><hr></td></tr>\n";
print "<tr><td>&nbsp;</td><td>\n";
print '<input type="submit" name="modify" value="'.__("Valider").'"> <input type="reset" value="'.__("Rinitialiser").'">'."\n";
print "</td></tr>\n";
print "</table>\n";
print '<input type="hidden" name="id" value="'.$group.'">'."\n";
if ($q->param("all"))
{
    print '<input type="hidden" name="all" value="1">'."\n";
}
if ($q->param("addgr"))
{
    print '<input type="hidden" name="addgr" value="1">'."\n";
}
if ($q->param("group"))
{
    print '<input type="hidden" name="group" value="'.$q->param("group").'">'."\n";
}

print "</form>\n";

cw_footer();
